#include "mainwindow.h"
#include "myglwidget.h"
#include <QSlider>
#include <QHBoxLayout>
#include "scene.h"
MainWindow::MainWindow(QWidget *parent)
    : QWidget(parent)
{
    MyGLWidget *gl = new MyGLWidget();
    Scene* scene = new Scene();
    gl->setScene(scene);

    QSlider *sliderX = new QSlider(Qt::Vertical);
    QSlider *sliderY = new QSlider(Qt::Vertical);
    QSlider *sliderZ = new QSlider(Qt::Vertical);
    sliderX->setRange(0, 360);
    sliderY->setRange(0, 360);
    sliderZ->setRange(0, 360);

    QLayout* layout = new QHBoxLayout();

    layout->addWidget(gl);
    layout->addWidget(sliderX);
    layout->addWidget(sliderY);
    layout->addWidget(sliderZ);

    this->setLayout(layout);

    connect(sliderX, SIGNAL(valueChanged(int)), gl, SLOT(rotateX(int)));
    connect(sliderY, SIGNAL(valueChanged(int)), gl, SLOT(rotateY(int)));
    connect(sliderZ, SIGNAL(valueChanged(int)), gl, SLOT(rotateZ(int)));

    connect(scene, SIGNAL(rotationXChanged(int)), sliderX, SLOT(setValue(int)));
    connect(scene, SIGNAL(rotationYChanged(int)), sliderY, SLOT(setValue(int)));
    connect(scene, SIGNAL(rotationZChanged(int)), sliderZ, SLOT(setValue(int)));

}

MainWindow::~MainWindow()
{

}

QSize
MainWindow::sizeHint() const
{
    return QSize(800, 600);
}
