#ifndef SCENE_H
#define SCENE_H

#include <GL/gl.h>
#include <string>
#include "Matrix.h"
#include <QObject>

class Node;
class CameraNode;

class Scene : public QObject
{
    Q_OBJECT
public:
    Scene(QObject* parent=NULL);
    virtual ~Scene();
    void render();
    GLdouble* getNodeTransform(Node* node);

    void rotateCamX(int);
    void rotateCamY(int);
    void rotateCamZ(int);
    void focus(const std::string& nodeName);
signals:
    void rotationXChanged(int);
    void rotationYChanged(int);
    void rotationZChanged(int);
private:
    Node* root;
    Node*red, *blue;
    CameraNode* camera;

    GLdouble* camPos;
    GLdouble* lookPos;

    Matrix forwardApply(Node* node);
    void replaceCamRotationNode(Node* newNode);
    float rotX, rotY, rotZ;
    bool wasFocussed;
};

#endif // SCENE_H
